'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var Numeral = /*#__PURE__*/function () {
  function Numeral(value) {
    var _this = this;

    _classCallCheck(this, Numeral);

    _defineProperty(this, "value", void 0);

    _defineProperty(this, "set", function (val) {
      _this.value = Numeral.cast(val);
      return _this;
    });

    _defineProperty(this, "valueOf", function () {
      return _this.value;
    });

    _defineProperty(this, "clone", function () {
      return new Numeral(_this.value);
    });

    _defineProperty(this, "toFixed", function (decimals) {
      var v = _this.value;
      var scale = Math.pow(10, decimals !== null && decimals !== void 0 ? decimals : 10);
      v = Math.round(v * scale) / scale;
      return decimals ? v.toFixed(decimals) : v.toString();
    });

    this.value = Numeral.cast(value);
  }

  _createClass(Numeral, [{
    key: "decimals",
    get: function get() {
      if (!Numeral.is(this.value)) return 0;
      var e = 1;
      var p = 0;

      while (Math.round(this.value * e) / e !== this.value) {
        e *= 10;
        p += 1;
      }

      return p;
    }
  }]);

  return Numeral;
}();

_defineProperty(Numeral, "cast", function (value) {
  var num = Number.parseFloat(value.toString());
  return !isNaN(num) ? num : 0;
});

_defineProperty(Numeral, "is", function (v) {
  if (typeof v !== "number") return false;
  return !isNaN(v) || isFinite(v);
});

var numeral = function numeral(val) {
  return new Numeral(val);
};

exports.Numeral = Numeral;
exports.numeral = numeral;
